#!/bin/bash
# Зададим переменные
SHELL=/bin/bash
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin 

PathToDir=/home/basebackup

LOGFILE=$PathToDir/backup.log
BASESLIST=$PathToDir/bases.list
source $PathToDir/access.setting

DAY=$(date +%a)
DAYOFMONTH=$(date +%d)
DATE=$(date +%Y%m%d)

#Резервное копирование

# ежедневное копирование 
echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " start dayly backup" >>$LOGFILE
# начало цикла перебора баз из файла bases.list
# если строка закомментирована то пропускаем строку
while read LINE 
do
if [[ $LINE == '#'* ]]
then echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" "skip " $LINE >>$LOGFILE
continue
fi
FileName=$DAY.$LINE.pgsql.gz

echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE " start dump" >>$LOGFILE

pg_dump -U $PG_user -h $PG_server $LINE | gzip > $FileName

echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE " dump done" >>$LOGFILE
echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE "start send to ftp in " $FileName >>$LOGFILE

ftp -n $FTP_server <<END_SCRIPT
quote USER $FTP_user
quote PASS $FTP_user_password
cd $FTP_dir
put $FileName 
quit
END_SCRIPT
echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE " done send to ftp" >>$LOGFILE


# ежемесячное копирование
if [[ $DAYOFMONTH == "01" ]]
then
NewFileName=$DATE.$LINE.pgsql.gz

echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " monthly backup" >>$LOGFILE

echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE "start send to ftp in " $NewFileName >>$LOGFILE

ftp -n $FTP_server <<END_SCRIPT
quote USER $FTP_user
quote PASS $FTP_user_password
cd $FTP_dir
put $FileName $NewFileName
quit
END_SCRIPT

echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " base " $LINE " done send to ftp" >>$LOGFILE

fi


#Удаляем ненужный уже файл
rm -f $FileName
done < $BASESLIST
# конец цикла
echo "["$(date +%Y/%m/%d_%H:%M:%S)"]" " done backup" >>$LOGFILE
